'use strict'

function page_profile_panel_notification_create(form, html = 0) {
    if (form == undefined) {
        form = {
            '_csrf': yii.getCsrfToken()
        };
    } else {
        form = $(form).serializeArray();

        // Запись параметра типа уведомления (тест и html-код)
        form.push({
            name: 'Notification[html]',
            value: html
        });
    };

    return page_profile_panel_write(form);
};

function page_profile_panel_settings(form, panel) {
    if (form == undefined) {
        form = {
            '_csrf': yii.getCsrfToken()
        };

        if (panel !== undefined) {
            form.panel = panel;
        };
    } else {
        form = $(form).serializeArray();

        form.push({
            name: "panel",
            value: panel
        });
    };

    return page_profile_panel_write(form);
};

function page_profile_panel_write(form) {
    $.ajax({
        url: '/profile/panel',
        type: 'post',
        dataType: 'json',
        data: form,
        success: page_profile_response_success,
        error: page_profile_response_error
    });

    return false;
};

function page_profile_panel_input_suppliers_requests_init() {
    // Инициализация скриптов при открытии вкладки "Поставщики"

    // Выбор панели
    page_profile_panel_suppliers_choose('profile_panel_input_suppliers');

    // Инициализация панели
    page_profile_panel_input_suppliers_requests_init();

    return false;
};

function page_profile_panel_suppliers_choose(button) {

    if (button === 'profile_panel_input_suppliers') {
        document.getElementById('profile_panel_input_notifications').addAttribute('onclick', 'return page_profile_panel_input_suppliers_notifications_init();');
        document.getElementById('profile_panel_input_settings').addAttribute('onclick', 'return page_profile_panel_input_suppliers_settings_init();');
    } else if (button === 'profile_panel_input_notifications') {
        document.getElementById('profile_panel_input_suppliers').addAttribute('onclick', 'return page_profile_panel_input_suppliers_requests_init();');
        document.getElementById('profile_panel_input_settings').addAttribute('onclick', 'return page_profile_panel_input_suppliers_settings_init();');
    } else if (button === 'profile_panel_input_settings') {
        document.getElementById('profile_panel_input_notifications').addAttribute('onclick', 'return page_profile_panel_input_suppliers_notifications_init();');
        document.getElementById('profile_panel_input_suppliers').addAttribute('onclick', 'return page_profile_panel_input_suppliers_requests_init();');
    }

    document.getElementById(button).removeAttribute('onclick');
}

function page_profile_panel_input_suppliers_requests_init(wrap = 'profile_panel_input_suppliers_requests') {
    // Инициализация блока "Заявки на регистрацию" (поставщиков)

    // Инициализация оболочки
    wrap = document.getElementById(wrap);

    $.ajax({
        url: '/profile/panel/suppliers/requests/search',
        type: 'post',
        dataType: 'json',
        data: {
            '_csrf': yii.getCsrfToken()
        },
        success: (data, status, xhr) => {
            // Обработка ответа

            if (data !== undefined) {
                // Получены данные с сервера

                if (data.suppliers !== undefined && data.suppliers !== null) {
                    // Найдены данные поставщиков

                    for (let html of page_profile_panel_input_suppliers_requests_generate(data.suppliers)) {
                        // Перебор сгенерированных HTML-элементов

                        // Запись в документ
                        wrap.appendChild(html);
                    }
                }
            }

            // Переход к остальным обработчикам
            page_profile_response_success(data, status, xhr);
        },
        error: page_profile_response_error
    });
}

function page_profile_panel_input_suppliers_requests_generate(suppliers) {
    // Генерация HTML со списком заявок на регистрацию поставщиков

    // Инициализация буфера вывода
    let html = new Set;

    // Инициализация итератора
    let i = 0;

    for (let account of suppliers) {
        // Перебор данных поставщиков

        // Обновление счётчика
        ++i;

        // Инициализация контейнера
        let container = document.createElement('div');
        container.setAttribute('id', 'profile_panel_input_suppliers_requests_block_' + account._key);
        container.setAttribute('class', i < suppliers.length ? 'mb-3 px-3 py-1 row' : 'px-3 py-1 row');

        // Инициализация колонки с метаданными аккаунта
        let block_metadata = document.createElement('div');
        block_metadata.setAttribute('id', 'profile_panel_input_suppliers_requests_block_metadata_' + account._key);
        block_metadata.setAttribute('class', 'col-4 pl-0 d-flex flex-column');

        // Инициализация оболочки идентификатора аккаунта
        let wrap_id = document.createElement('p');
        wrap_id.setAttribute('class', 'mt-0 mb-2 px-3 row');

        // Инициализация ярлыка идентификатора аккаунта
        let label_id = document.createElement('b');
        label_id.setAttribute('class', '');
        label_id.innerText = 'Договор:';

        // Инициализация значения идентификатора аккаунта
        let value_id = document.createElement('span');
        value_id.setAttribute('class', 'ml-auto');
        value_id.innerText = account._key;

        // Инициализация оболочки времени регистрации
        let wrap_regs = document.createElement('p');
        wrap_regs.setAttribute('class', 'mt-auto mb-2 px-3 row');

        // Инициализация ярлыка времени регистрации
        let label_regs = document.createElement('b');
        label_regs.setAttribute('class', '');
        label_regs.innerText = 'Регистрация:';

        // Инициализация значения времени регистрации
        let value_regs = document.createElement('span');
        value_regs.setAttribute('class', 'ml-auto');
        value_regs.innerText = moment.unix(account.date.regs).locale('ru-ru').format('DD.MM.YYYY');

        // Инициализация оболочки времени заявки
        let wrap_supl = document.createElement('p');
        wrap_supl.setAttribute('class', 'mt-0 mb-2 px-3 row');

        // Инициализация ярлыка времени заявки
        let label_supl = document.createElement('b');
        label_supl.setAttribute('class', '');
        label_supl.innerText = 'Заявка:';

        // Инициализация значения времени заявки
        let value_supl = document.createElement('span');
        value_supl.setAttribute('class', 'ml-auto');
        value_supl.innerText = moment.unix(account.date.supl).locale('ru-ru').format('DD.MM.YYYY');

        // Инициализация кнопки сохранения
        let button_save = document.createElement('a');
        button_save.setAttribute('class', 'btn form-control button_blue');
        button_save.setAttribute('type', 'button');
        button_save.setAttribute('role', 'button');
        button_save.innerText = 'Сохранить';

        // Инициализация колонки с основными данными аккаунта
        let block_info = document.createElement('div');
        block_info.setAttribute('id', 'profile_panel_input_suppliers_requests_block_info_' + account._key);
        block_info.setAttribute('class', 'col-4 d-flex flex-column');

        // Инициализация ярлыка "NAME"
        let label_name = document.createElement('label');
        label_name.setAttribute('class', 'control-label');
        label_name.innerText = 'Имя';

        // Инициализация поля "NAME"
        let input_name = document.createElement('input');
        input_name.setAttribute('id', 'profile_panel_input_suppliers_requests_block_info_name_' + account._key);
        input_name.setAttribute('class', 'form-control button_clean mb-3');
        input_name.setAttribute('type', 'text');
        input_name.setAttribute('onchange', 'return profile_panel_input_suppliers_requests_block_name_edit(' + account._key + ', this);');
        input_name.value = account.name;

        // Инициализация ярлыка "SIMC" (телефон)
        let label_simc = document.createElement('label');
        label_simc.setAttribute('class', 'control-label');
        label_simc.innerText = 'Номер';

        // Инициализация поля "SIMC" (телефон)
        let input_simc = document.createElement('input');
        input_simc.setAttribute('id', 'profile_panel_input_suppliers_requests_block_info_simc_' + account._key);
        input_simc.setAttribute('class', 'form-control button_clean mb-3');
        input_simc.setAttribute('type', 'number');
        input_simc.setAttribute('onchange', 'return profile_panel_input_suppliers_requests_block_simc_edit(' + account._key + ', this);');
        input_simc.value = account.simc;

        // Инициализация ярлыка "MAIL"
        let label_mail = document.createElement('label');
        label_mail.setAttribute('class', 'control-label');
        label_mail.innerText = 'Почта';

        // Инициализация поля "MAIL"
        let input_mail = document.createElement('input');
        input_mail.setAttribute('id', 'profile_panel_input_suppliers_requests_block_info_mail_' + account._key);
        input_mail.setAttribute('class', 'form-control button_clean');
        input_mail.setAttribute('type', 'mail');
        input_mail.setAttribute('onchange', 'return profile_panel_input_suppliers_requests_block_mail_edit(' + account._key + ', this);');
        input_mail.value = account.mail;

        // Инициализация колонки с вторичными данными аккаунта
        let block_details = document.createElement('div');
        block_details.setAttribute('id', 'profile_panel_input_suppliers_requests_block_details_' + account._key);
        block_details.setAttribute('class', 'col-4 pr-0 d-flex flex-column');

        // Инициализация ярлыка "INDX"
        let label_indx = document.createElement('label');
        label_indx.setAttribute('class', 'control-label');
        label_indx.innerText = 'Индекс';

        // Инициализация оболочки "INDX"
        let wrap_indx = document.createElement('div');
        wrap_indx.setAttribute('class', 'row mx-0 mb-3');

        // Инициализация поля "INDX"
        let input_indx = document.createElement('input');
        input_indx.setAttribute('id', 'profile_panel_input_suppliers_requests_block_info_indx_' + account._key);
        input_indx.setAttribute('class', 'col form-control button_clean');
        input_indx.setAttribute('type', 'text');
        input_indx.setAttribute('onchange', 'return profile_panel_input_suppliers_requests_block_indx_edit(' + account._key + ', this);');
        input_indx.value = account.indx;

        // Инициализация кнопки "INDX"
        let button_indx = document.createElement('a');
        button_indx.setAttribute('class', 'ml-2 my-auto text-dark');
        button_indx.setAttribute('type', 'button');
        button_indx.setAttribute('role', 'button');
        button_indx.innerHTML = '<i class="fas fa-redo-alt"></i>';

        // Инициализация ярлыка "PSWD"
        let label_pswd = document.createElement('label');
        label_pswd.setAttribute('class', 'control-label');
        label_pswd.innerText = 'Пароль';

        // Инициализация оболочки "PSWD"
        let wrap_pswd = document.createElement('div');
        wrap_pswd.setAttribute('class', 'row mx-0 mb-3');

        // Инициализация поля "PSWD"
        let input_pswd = document.createElement('input');
        input_pswd.setAttribute('id', 'profile_panel_input_suppliers_requests_block_info_pswd_' + account._key);
        input_pswd.setAttribute('class', 'col form-control button_clean');
        input_pswd.setAttribute('type', 'text');
        input_pswd.setAttribute('onchange', 'return profile_panel_input_suppliers_requests_block_pswd_edit(' + account._key + ', this);');
        input_pswd.value = account.pswd;

        // Инициализация кнопки "PSWD"
        let button_pswd = document.createElement('a');
        button_pswd.setAttribute('class', 'ml-2 my-auto text-dark');
        button_pswd.setAttribute('type', 'button');
        button_pswd.setAttribute('role', 'button');
        button_pswd.innerHTML = '<i class="fas fa-redo-alt"></i>';

        // Инициализация ярлыка "FILE"
        let label_file = document.createElement('label');
        label_file.setAttribute('class', 'control-label');
        label_file.innerText = 'Карточка предприятия';

        // Инициализация ссылки на "FILE"
        let button_file = document.createElement('a');
        button_file.setAttribute('class', 'btn form-control button_blue');
        button_file.setAttribute('href', '/' + account._key + '/requests/supplier/' + account.date.supl + '/document');
        button_file.innerHTML = 'Скачать';

        // Компоновка элементов блока с основной информацией
        wrap_id.appendChild(label_id);
        wrap_id.appendChild(value_id);
        block_metadata.appendChild(wrap_id);
        wrap_regs.appendChild(label_regs);
        wrap_regs.appendChild(value_regs);
        block_metadata.appendChild(wrap_regs);
        wrap_supl.appendChild(label_supl);
        wrap_supl.appendChild(value_supl);
        block_metadata.appendChild(wrap_supl);
        block_metadata.appendChild(button_save);

        // Компоновка элементов блока с основной информацией
        block_info.appendChild(label_name);
        block_info.appendChild(input_name);
        block_info.appendChild(label_simc);
        block_info.appendChild(input_simc);
        block_info.appendChild(label_mail);
        block_info.appendChild(input_mail);

        // Компоновка элементов блока с вторичными данными
        block_details.appendChild(label_indx);
        wrap_indx.appendChild(input_indx);
        wrap_indx.appendChild(button_indx);
        block_details.appendChild(wrap_indx);
        block_details.appendChild(label_pswd);
        wrap_pswd.appendChild(input_pswd);
        wrap_pswd.appendChild(button_pswd);
        block_details.appendChild(wrap_pswd);
        block_details.appendChild(label_file);
        block_details.appendChild(button_file);

        // Компоновка всех колонок
        container.appendChild(block_metadata);
        container.appendChild(block_info);
        container.appendChild(block_details);

        html.add(container);

        if (i < suppliers.length) {
            // Это не последний элемент в списке

            // Инициализация разделителя (разобраться почему его надо генерировать заново - удаляется после add)
            let divider = document.createElement('div');
            divider.setAttribute('class', 'dropdown-divider mx-2 mb-2');

            // Добавить разделитель
            html.add(divider);
        }
    }

    // Возврат
    return html;
}
